#include <ncurses.h>
#include "common.h"
#include "proto.h"

int load_map(char *filename, char map[MAP_YSIZE][MAP_XSIZE]);

int load_map(char *filename, char map[MAP_YSIZE][MAP_XSIZE])
{
  int x, y;
  FILE *fp;
  int c;

  fp = fopen(filename, "r");
  if(fp == NULL) {
    return 1;
  }

  for(y = 0; y < MAP_YSIZE; y++) {
    for(x = 0; x < MAP_XSIZE; x++) {

      map[y][x] = 0;

      c = fgetc(fp);
      if(c == EOF) {
        fclose(fp);
        return 1;
      }
	
      if((x<MAX_MAP_X && y<MAX_MAP_Y) || map[y][x]==MAP_WALL){	
     	 map[y][x] = c;
      }
  

    }
  }

  map[2][2] = ':';
  map[2][3] = ':';
  map[3][2] = ':';
  map[3][3] = ':';
  map[4][4] = CHR_WALL;
  map[4][1] = CHR_WALL;
  map[4][2] = CHR_WALL;
  map[4][3] = CHR_WALL;
  map[3][4] = CHR_WALL;
  map[3][5] = CHR_WALL;

  for(x = 0; x < MAX_MAP_X; x++) {
     map[20][x] =CHR_WALL;
  }

   for(y = 0; y < MAX_MAP_Y; y++) {
     map[y][77] = CHR_WALL;
  }


  fclose(fp);

  return 0;
}
